package be.iminds.ilabt.jfed.lowlevel.connection;

import be.iminds.ilabt.jfed.lowlevel.JFedException;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.protocol.HttpContext;

/**
 * BasicHttpConnection
 */
public class BasicHttpConnection extends HttpConnection {
    private DefaultHttpClient httpClient;
    private final HttpContext httpContext;
    private final HttpContext preemptiveAuthHttpContext;

    private boolean preemptiveAuthEnabled = false;

    public BasicHttpConnection(ConnectionConfig connectionConfig,
                               DefaultHttpClient httpClient, HttpContext httpContext, HttpContext preemptiveAuthHttpContext) throws JFedException {
        super(connectionConfig);
        this.httpClient = httpClient;
        this.httpContext = httpContext;
        this.preemptiveAuthHttpContext = preemptiveAuthHttpContext;
    }

    @Override
    public void enablePreemptiveAuthentication(boolean enable) {
        preemptiveAuthEnabled = enable;
    }

    @Override
    public DefaultHttpClient getHttpClient() {
        return httpClient;
    }

    @Override
    public HttpContext getHttpContext() {
        if (preemptiveAuthEnabled)
            return preemptiveAuthHttpContext;
        else
            return httpContext;
    }

    @Override
    public void close() {
        error = true;
        httpClient = null;
    }
}

